diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc	2024-10-09 16:41:10.140657000 -0700
+++ ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -4768,14 +4778,14 @@
     /**
      * Set TRIGVECTOR for HE TB PPDU
      *
-     * \param ppduDuration the duration of the HE TB PPDU
+     * @param ppduDuration the duration of the HE TB PPDU
      */
     void SetTrigVector(Time ppduDuration);
 
     /**
      * Generate interference function
-     * \param interferencePsd the PSD of the interference to be generated
-     * \param duration the duration of the interference
+     * @param interferencePsd the PSD of the interference to be generated
+     * @param duration the duration of the interference
      */
     void GenerateInterference(Ptr<SpectrumValue> interferencePsd, Time duration);
     /**
@@ -4790,9 +4800,9 @@
 
     /**
      * Check the received PSDUs from STA1
-     * \param expectedSuccess the expected number of success
-     * \param expectedFailures the expected number of failures
-     * \param expectedBytes the expected number of bytes
+     * @param expectedSuccess the expected number of success
+     * @param expectedFailures the expected number of failures
+     * @param expectedBytes the expected number of bytes
      */
     void CheckRxFromSta1(uint32_t expectedSuccess,
                          uint32_t expectedFailures,
@@ -4800,9 +4810,9 @@
 
     /**
      * Check the received PSDUs from STA2
-     * \param expectedSuccess the expected number of success
-     * \param expectedFailures the expected number of failures
-     * \param expectedBytes the expected number of bytes
+     * @param expectedSuccess the expected number of success
+     * @param expectedFailures the expected number of failures
+     * @param expectedBytes the expected number of bytes
      */
     void CheckRxFromSta2(uint32_t expectedSuccess,
                          uint32_t expectedFailures,
@@ -4815,11 +4825,11 @@
 
     /**
      * Check the PHY state
-     * \param phy the PHY
-     * \param expectedState the expected state of the PHY
+     * @param phy the PHY
+     * @param expectedState the expected state of the PHY
      */
     void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
-    /// \copydoc CheckPhyState
+    /// @copydoc CheckPhyState
     void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
 
     /**
@@ -4829,19 +4839,19 @@
 
     /**
      * Receive success function
-     * \param psdu the PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector the transmit vector
-     * \param statusPerMpdu reception status per MPDU
+     * @param psdu the PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector the transmit vector
+     * @param statusPerMpdu reception status per MPDU
      */
     void RxSuccess(Ptr<const WifiPsdu> psdu,
                    RxSignalInfo rxSignalInfo,
-                   WifiTxVector txVector,
-                   std::vector<bool> statusPerMpdu);
+                   const WifiTxVector& txVector,
+                   const std::vector<bool>& statusPerMpdu);
 
     /**
      * Receive failure function
-     * \param psdu the PSDU
+     * @param psdu the PSDU
      */
     void RxFailure(Ptr<const WifiPsdu> psdu);
 
@@ -4946,8 +4956,8 @@
 void
 TestPhyPaddingExclusion::RxSuccess(Ptr<const WifiPsdu> psdu,
                                    RxSignalInfo rxSignalInfo,
-                                   WifiTxVector txVector,
-                                   std::vector<bool> /*statusPerMpdu*/)
+                                   const WifiTxVector& txVector,
+                                   const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << *psdu << psdu->GetAddr2() << rxSignalInfo << txVector);
     if (psdu->GetAddr2() == Mac48Address("00:00:00:00:00:01"))
@@ -5066,7 +5076,7 @@
 
     Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
     Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel>();
-    lossModel->SetFrequency(DEFAULT_FREQUENCY * 1e6);
+    lossModel->SetFrequency(MHzToHz(DEFAULT_FREQUENCY));
     spectrumChannel->AddPropagationLossModel(lossModel);
     Ptr<ConstantSpeedPropagationDelayModel> delayModel =
         CreateObject<ConstantSpeedPropagationDelayModel>();
@@ -5209,17 +5219,17 @@
     Time ppduWithPaddingDuration =
         expectedPpduDuration + 10 * NanoSeconds(12800 + 1600 /* GI */); // add 10 extra OFDM symbols
 
-    Simulator::Schedule(Seconds(0.0), &TestPhyPaddingExclusion::Reset, this);
+    Simulator::Schedule(Seconds(0), &TestPhyPaddingExclusion::Reset, this);
 
     // STA1 and STA2 send MU UL PPDUs addressed to AP:
-    Simulator::Schedule(Seconds(1.0),
+    Simulator::Schedule(Seconds(1),
                         &TestPhyPaddingExclusion::SendHeTbPpdu,
                         this,
                         1,
                         1,
                         1000,
                         ppduWithPaddingDuration);
-    Simulator::Schedule(Seconds(1.0),
+    Simulator::Schedule(Seconds(1),
                         &TestPhyPaddingExclusion::SendHeTbPpdu,
                         this,
                         2,
@@ -5228,18 +5238,18 @@
                         ppduWithPaddingDuration);
 
     // Set TRIGVECTOR on AP
-    Simulator::Schedule(Seconds(1.0),
+    Simulator::Schedule(Seconds(1),
                         &TestPhyPaddingExclusion::SetTrigVector,
                         this,
                         ppduWithPaddingDuration);
 
     // Verify it takes expectedPpduDuration + padding to transmit the PPDUs
-    Simulator::Schedule(Seconds(1.0) + ppduWithPaddingDuration - NanoSeconds(1),
+    Simulator::Schedule(Seconds(1) + ppduWithPaddingDuration - NanoSeconds(1),
                         &TestPhyPaddingExclusion::CheckPhyState,
                         this,
                         m_phyAp,
                         WifiPhyState::RX);
-    Simulator::Schedule(Seconds(1.0) + ppduWithPaddingDuration,
+    Simulator::Schedule(Seconds(1) + ppduWithPaddingDuration,
                         &TestPhyPaddingExclusion::CheckPhyState,
                         this,
                         m_phyAp,
@@ -5255,14 +5265,14 @@
     Simulator::Schedule(Seconds(1.5), &TestPhyPaddingExclusion::Reset, this);
 
     // STA1 and STA2 send MU UL PPDUs addressed to AP:
-    Simulator::Schedule(Seconds(2.0),
+    Simulator::Schedule(Seconds(2),
                         &TestPhyPaddingExclusion::SendHeTbPpdu,
                         this,
                         1,
                         1,
                         1000,
                         ppduWithPaddingDuration);
-    Simulator::Schedule(Seconds(2.0),
+    Simulator::Schedule(Seconds(2),
                         &TestPhyPaddingExclusion::SendHeTbPpdu,
                         this,
                         2,
@@ -5271,25 +5281,25 @@
                         ppduWithPaddingDuration);
 
     // Set TRIGVECTOR on AP
-    Simulator::Schedule(Seconds(2.0),
+    Simulator::Schedule(Seconds(2),
                         &TestPhyPaddingExclusion::SetTrigVector,
                         this,
                         ppduWithPaddingDuration);
 
     // A strong non-wifi interference is generated on RU 1 during padding reception
     BandInfo bandInfo;
-    bandInfo.fc = (DEFAULT_FREQUENCY - (DEFAULT_CHANNEL_WIDTH / 4)) * 1e6;
-    bandInfo.fl = bandInfo.fc - ((DEFAULT_CHANNEL_WIDTH / 4) * 1e6);
-    bandInfo.fh = bandInfo.fc + ((DEFAULT_CHANNEL_WIDTH / 4) * 1e6);
+    bandInfo.fc = MHzToHz(DEFAULT_FREQUENCY - (DEFAULT_CHANNEL_WIDTH / 4));
+    bandInfo.fl = bandInfo.fc - MHzToHz(DEFAULT_CHANNEL_WIDTH / 4);
+    bandInfo.fh = bandInfo.fc + MHzToHz(DEFAULT_CHANNEL_WIDTH / 4);
     Bands bands;
     bands.push_back(bandInfo);
 
     Ptr<SpectrumModel> SpectrumInterferenceRu1 = Create<SpectrumModel>(bands);
     Ptr<SpectrumValue> interferencePsdRu1 = Create<SpectrumValue>(SpectrumInterferenceRu1);
     Watt_u interferencePower{0.1};
-    *interferencePsdRu1 = interferencePower / ((DEFAULT_CHANNEL_WIDTH / 2) * 20e6);
+    *interferencePsdRu1 = interferencePower / (MHzToHz(DEFAULT_CHANNEL_WIDTH / 2) * 20);
 
-    Simulator::Schedule(Seconds(2.0) + MicroSeconds(50) + expectedPpduDuration,
+    Simulator::Schedule(Seconds(2) + MicroSeconds(50) + expectedPpduDuration,
                         &TestPhyPaddingExclusion::GenerateInterference,
                         this,
                         interferencePsdRu1,
@@ -5297,12 +5307,12 @@
 
     // Verify it takes  expectedPpduDuration + padding to transmit the PPDUs (PHY should move to
     // CCA_BUSY instead of IDLE due to the interference)
-    Simulator::Schedule(Seconds(2.0) + ppduWithPaddingDuration - NanoSeconds(1),
+    Simulator::Schedule(Seconds(2) + ppduWithPaddingDuration - NanoSeconds(1),
                         &TestPhyPaddingExclusion::CheckPhyState,
                         this,
                         m_phyAp,
                         WifiPhyState::RX);
-    Simulator::Schedule(Seconds(2.0) + ppduWithPaddingDuration,
+    Simulator::Schedule(Seconds(2) + ppduWithPaddingDuration,
                         &TestPhyPaddingExclusion::CheckPhyState,
                         this,
                         m_phyAp,
@@ -5324,10 +5334,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief UL-OFDMA power control test
+ * @brief UL-OFDMA power control test
  */
 class TestUlOfdmaPowerControl : public TestCase
 {
@@ -5343,7 +5353,7 @@
     /**
      * Send a MU BAR through the AP to the STAs listed in the provided vector.
      *
-     * \param staIds the vector of STA-IDs of STAs to address the MU-BAR to
+     * @param staIds the vector of STA-IDs of STAs to address the MU-BAR to
      */
     void SendMuBar(std::vector<uint16_t> staIds);
 
@@ -5351,14 +5361,14 @@
      * Send a QoS Data packet to the destination station in order
      * to set up a block Ack session (so that the MU-BAR may have a reply).
      *
-     * \param destination the address of the destination station
+     * @param destination the address of the destination station
      */
     void SetupBa(Address destination);
 
     /**
      * Run one simulation with an optional BA session set up phase.
      *
-     * \param setupBa true if BA session should be set up (i.e. upon first run),
+     * @param setupBa true if BA session should be set up (i.e. upon first run),
      *                false otherwise
      */
     void RunOne(bool setupBa);
@@ -5373,15 +5383,15 @@
      * Receive OK callback function at AP.
      * This method will be plugged into the AP PHY's ReceiveOkCallback once the
      * block Ack session has been set up. This is done in the Reset function.
-     * \param psdu the PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector the TXVECTOR used for the packet
-     * \param statusPerMpdu reception status per MPDU
+     * @param psdu the PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector the TXVECTOR used for the packet
+     * @param statusPerMpdu reception status per MPDU
      */
     void ReceiveOkCallbackAtAp(Ptr<const WifiPsdu> psdu,
                                RxSignalInfo rxSignalInfo,
-                               WifiTxVector txVector,
-                               std::vector<bool> statusPerMpdu);
+                               const WifiTxVector& txVector,
+                               const std::vector<bool>& statusPerMpdu);
 
     uint8_t m_bssColor; ///< BSS color
 
@@ -5408,15 +5418,15 @@
 TestUlOfdmaPowerControl::TestUlOfdmaPowerControl()
     : TestCase("UL-OFDMA power control test"),
       m_bssColor(1),
-      m_txPowerAp(0),
-      m_txPowerStart(0),
-      m_txPowerEnd(0),
+      m_txPowerAp(dBm_u{0}),
+      m_txPowerStart(dBm_u{0}),
+      m_txPowerEnd(dBm_u{0}),
       m_txPowerLevels(0),
-      m_requestedRssiSta1(0),
-      m_requestedRssiSta2(0),
-      m_rssiSta1(0),
-      m_rssiSta2(0),
-      m_tol(0.1)
+      m_requestedRssiSta1(dBm_u{0}),
+      m_requestedRssiSta2(dBm_u{0}),
+      m_rssiSta1(dBm_u{0}),
+      m_rssiSta2(dBm_u{0}),
+      m_tol(dB_u{0.1})
 {
 }
 
@@ -5538,10 +5548,10 @@
 
     auto nav = m_apDev->GetPhy()->GetSifs();
     const auto staId = staIds.front(); // either will do
-    nav += m_phyAp->CalculateTxDuration(GetBlockAckSize(BlockAckType::COMPRESSED),
-                                        tbTxVector,
-                                        DEFAULT_WIFI_BAND,
-                                        staId);
+    nav += SpectrumWifiPhy::CalculateTxDuration(GetBlockAckSize(BlockAckType::COMPRESSED),
+                                                tbTxVector,
+                                                DEFAULT_WIFI_BAND,
+                                                staId);
     psdu->SetDuration(nav);
     psdus.insert(std::make_pair(SU_STA_ID, psdu));
 
@@ -5551,8 +5561,8 @@
 void
 TestUlOfdmaPowerControl::ReceiveOkCallbackAtAp(Ptr<const WifiPsdu> psdu,
                                                RxSignalInfo rxSignalInfo,
-                                               WifiTxVector txVector,
-                                               std::vector<bool> /*statusPerMpdu*/)
+                                               const WifiTxVector& txVector,
+                                               const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_TEST_ASSERT_MSG_EQ(txVector.GetPreambleType(), WIFI_PREAMBLE_HE_TB, "HE TB PPDU expected");
     const auto rssi = rxSignalInfo.rssi;
@@ -5758,24 +5768,24 @@
 TestUlOfdmaPowerControl::DoRun()
 {
     // Power configurations
-    m_txPowerAp = 20;    // dBm, so as to have -30 and -36 dBm at STA 1 and STA 2 resp.,
-                         // since path loss = 50 dB for AP <-> STA 1 and 56 dB for AP <-> STA 2
-    m_txPowerStart = 15; // dBm
+    m_txPowerAp = dBm_u{20}; // so as to have -30 and -36 dBm at STA 1 and STA 2 resp., since path
+                             // loss = 50 dB for AP <-> STA 1 and 56 dB for AP <-> STA 2
+    m_txPowerStart = dBm_u{15};
 
     // Requested UL RSSIs: should correspond to 20 dBm transmit power at STAs
-    m_requestedRssiSta1 = -30.0;
-    m_requestedRssiSta2 = -36.0;
+    m_requestedRssiSta1 = dBm_u{-30};
+    m_requestedRssiSta2 = dBm_u{-36};
 
     // Test single power level
     {
         // STA power configurations: 15 dBm only
-        m_txPowerEnd = 15;
+        m_txPowerEnd = dBm_u{15};
         m_txPowerLevels = 1;
 
         // Expected UL RSSIs, considering that the provided power is 5 dB less than requested,
         // regardless of the estimated path loss.
-        m_rssiSta1 = -35.0; // 15 dBm - 50 dB
-        m_rssiSta2 = -41.0; // 15 dBm - 56 dB
+        m_rssiSta1 = dBm_u{-35}; // 15 dBm - 50 dB
+        m_rssiSta2 = dBm_u{-41}; // 15 dBm - 56 dB
 
         RunOne(true);
     }
@@ -5783,13 +5793,13 @@
     // Test 2 dBm granularity
     {
         // STA power configurations: [15:2:25] dBm
-        m_txPowerEnd = 25;
+        m_txPowerEnd = dBm_u{25};
         m_txPowerLevels = 6;
 
         // Expected UL RSSIs, considering that the provided power (21 dBm) is 1 dB more than
         // requested
-        m_rssiSta1 = -29.0; // 21 dBm - 50 dB
-        m_rssiSta2 = -35.0; // 21 dBm - 50 dB
+        m_rssiSta1 = dBm_u{-29}; // 21 dBm - 50 dB
+        m_rssiSta2 = dBm_u{-35}; // 21 dBm - 50 dB
 
         RunOne(false);
     }
@@ -5797,12 +5807,12 @@
     // Test 1 dBm granularity
     {
         // STA power configurations: [15:1:25] dBm
-        m_txPowerEnd = 25;
+        m_txPowerEnd = dBm_u{25};
         m_txPowerLevels = 11;
 
         // Expected UL RSSIs, considering that we can correctly tune the transmit power
-        m_rssiSta1 = -30.0; // 20 dBm - 50 dB
-        m_rssiSta2 = -36.0; // 20 dBm - 56 dB
+        m_rssiSta1 = dBm_u{-30}; // 20 dBm - 50 dB
+        m_rssiSta2 = dBm_u{-36}; // 20 dBm - 56 dB
 
         RunOne(false);
     }
@@ -5810,16 +5820,17 @@
     // Ask for different power levels (3 dB difference between HE_TB_PPDUs)
     {
         // STA power configurations: [15:1:25] dBm
-        m_txPowerEnd = 25;
+        m_txPowerEnd = dBm_u{25};
         m_txPowerLevels = 11;
 
         // Requested UL RSSIs
-        m_requestedRssiSta1 = -28.0; // 2 dB higher than previously -> Tx power = 22 dBm at STA 1
-        m_requestedRssiSta2 = -37.0; // 1 dB less than previously -> Tx power = 19 dBm at STA 2
+        m_requestedRssiSta1 =
+            dBm_u{-28}; // 2 dB higher than previously -> Tx power = 22 dBm at STA 1
+        m_requestedRssiSta2 = dBm_u{-37}; // 1 dB less than previously -> Tx power = 19 dBm at STA 2
 
         // Expected UL RSSIs, considering that we can correctly tune the transmit power
-        m_rssiSta1 = -28.0; // 22 dBm - 50 dB
-        m_rssiSta2 = -37.0; // 19 dBm - 56 dB
+        m_rssiSta1 = dBm_u{-28}; // 22 dBm - 50 dB
+        m_rssiSta2 = dBm_u{-37}; // 19 dBm - 56 dB
 
         RunOne(false);
     }
@@ -5828,10 +5839,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief wifi PHY OFDMA Test Suite
+ * @brief wifi PHY OFDMA Test Suite
  */
 class WifiPhyOfdmaTestSuite : public TestSuite
 {
